/* Author: Minjae Wee	mwee@uci.edu */
// Wumpus World - Average AI.hpp

#ifndef AverageAgent_hpp
#define AverageAgent_hpp

#include "Agent.hpp"
#include <algorithm>
#include <vector>
#include <string>

class AverageAgent : public Agent{
public:
	AverageAgent();
	bool checkPerceptIn(Percept p);
	void visitCell();
	void updateWumpusPitProb(int r, int c, char wum_or_pit, int prob, bool setvalue);
	void placeExaminePercepts();
	void updateBoardSize();
	void planMove(std::pair<std::string, Cell> move);
	std::pair<std::string, Cell> decideMove();
	std::vector<Cell> getPossibleMoves();
	std::string facingToString(std::pair<int,int> facing);
	std::string turnRight(std::string facing_temp);
	std::string turnLeft(std::string facing_temp);
	virtual Action getAction();
	virtual void perceiveResult(std::set<Percept> percepts);

private:
	int row;
	int col;
	int move_num;
	std::set<Agent::Percept> ps;
	std::vector<Action> move_proc;
	std::vector<Action> long_way_home;
	std::vector<std::vector<Cell>> board;
};

#endif /* AverageAgent_hpp */
