#ifndef World_hpp
#define World_hpp

#include <iostream>
#include "Tile.hpp"
#include "Helper.hpp"
#include "Agent.hpp"
#include "DummyAgent.hpp"
#include "PoorAgent.hpp"
#include "AverageAgent.hpp"
#include "SmartAgent.hpp"

class World{
    
public:
    World(int r, int c);
    ~World();
    
    void genWorld();
    
    void run();
    
	void printAgentDirection();
	void printPerceptions();
	void printBoard();
	void printLastAction();
	void printScore();
	void printGameInfo();
	void detectPercepts();

    bool running;
    bool gameOver;
	char turbo;


private:
    int row;
    int column;
	int points;

	SmartAgent agent;
	//AverageAgent agent;
	//PoorAgent agent;
	//DummyAgent agent;

	// The collection of perceptions needs to pass to agent
	std::set<Agent::Percept> ps;

    Tile** board;
    
    void updateBoard();
    bool notOutOfBound(int r, int c);
    void updateBreeze(int r, int c);
    void updateStench(int r, int c);
    
    std::pair<int,int> move(std::pair<int,int> p, std::pair<int,int> f);
    
    void allPercepts(std::set<Agent::Percept>& s, std::pair<int,int> p, std::pair<int,int> f);
    
	std::string getLastAction(Agent::Action a);
    std::string getPercept(Agent::Percept p);
    void printSet(std::set<Agent::Percept>& s);
};


#endif /* World_hpp */
