#include <iostream>
#include "World.hpp"
#include "Helper.hpp"

int getNumber(std::string msg){
	std::string c = "";
	while (true){
		try{
			std::cout << msg;
			std::cin >> c;
			if (4 <= stoi(c) <= 7)
				return stoi(c);
			else{
				std::cout << "Error, make sure the dimension is between 4-7";
				std::cin >> c;
			}
		}
		catch (...){
			std::cout << "Error, make sure you enter a numerical value!" << std::endl;
		}
	}
}
	
std::string getYesNo(std::string msg){
	std::string c="";
	while (true){
			std::cout << msg;
			std::cin >> c;
			if (c == "y" || c == "n")
				return c;
			else{
				std::cout << "Error, type 'y' or 'n'";
			}
	}
}

int main() {
	std::string restart="";
    // Set random seed
    srand(static_cast<unsigned> (time(0)));
    
    // Initialize the game board
	std::cout << "Welcome to Wumpus World!\n" << std::endl;
	int r = 4;
	int c = 4;
	while (restart != "q"){
		try{
			r = getNumber("\nSpecify the # rows/columns of the game board (4-7): ");
			c = r;
			std::string turbo_mode = getYesNo("\nWould you like to see game state one by one? ('y' or 'n'): ");
			std::cout << "Generated " << r << "x" << c << " game board!" << std::endl;
			World w = World(r, c);
			w.genWorld();
			w.printBoard();
			if (turbo_mode == "n")
				w.turbo = true;
			else
				w.turbo = false;
			
			// Print out score, perceptions, facing direction, and agent's last action
			w.detectPercepts();
			w.printGameInfo();

			// Start running
			w.run();
			std::cout << "\n\nType anything to play again or 'q' to quit!";
			std::cin >> restart;
		}
		catch (...){
			std::cout << "Invalid board size. Please try again!" << std::endl;
		}
	}
	std::cout << "Good-bye!" << std::endl;
    return 0;
}
